/*--------------------------------------------------------------------.
| menu.h                                                              |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#ifndef _MENU_
#define _MENU_

typedef struct
{
    char type;
    char fill;
    short count;
    long  maxsize;
    long  cursize;
    char  data[1];
} STHG;

typedef struct
{
    void *ptr;
    long len;
} SUDATA;

typedef long (*SCRAP_CB_t)(STHG *, SUDATA *);
typedef long (*MENU_CB_t) (int chan, int flag, short maxres, QD_text_t *res); 

int FileSelect (char *prompt, char *dir, char *ext, char *buf,short size,
                int xpos,int ypos,int mainc,int filec);
int DirSelect(char *prompt,char *buf,int lines,int xpos,int ypos,
              int mainc,int ddirc);
int ExtSelect(char *buf,int xpos,int ypos,int mainc);
int ItemSelect(char *name,char *prompt,char *item1,char *item2,char *item3,
               int xpos,int ypos,int mainc);
long ReportError(long errnum,int xpos,int ypos,int mainc);
long FileError(long errnum,unsigned char optns,int xpos,int ypos,int mainc);
int ReadString(char *name,char *prmpt,char *dflt,int chars,char *buf,
               int xpos,int ypos,int mainc);
void ViewFile(char *fname,char *start,char *end,short nchars,int mainc,int listc);
void Button(char *name,int xpos,int ypos,int mainc);
int ListSelect(char *name, char **items,int nitems,int mictl,
               int lines,int colms,int xpos,int ypos,int mainc,int listc,
               short *);
int CharSel(char *name,long avbit,char *buf,void *font,
            int xpos,int ypos,int mainc,int listc);
char *MenuInfo(long key,char *buf);

int ClearScrap(void);
int PutScrap(unsigned char dtyp,void *dataptr, unsigned long buflen, 
             SCRAP_CB_t func);
int GetScrap(unsigned char dtyp,void *dataptr, unsigned long buflen, 
             SCRAP_CB_t func);
int GetScrapInfo(unsigned char *datatype,
                 unsigned short *modifycount,
                 unsigned long *buflen);
int DoReport (char *name, char *desc, int chars, int xpos, int ypos, 
          int mainc, int mictl, MENU_CB_t func);

#define MENU_INIT

QD_text_t * __move_in(QD_text_t *s, char *t);
char *__restore(char *p, QD_text_t *q);
#define RESTORE error "RESTORE NOT SUPPORTED - SEE menu.h"
#define MOVEIN error "MOVEIN NOT SUPPORTED - SEE menu.h"
#define RESTORES(__p1,__p2) __restore(__p1,(QD_text_t *)__p2)
#define MOVEINS(__p1,__p2) __move_in((QD_text_t *)__p1,__p2)
#endif
