/*
 * hilight.h : static variables and tables definitions needed by highlighting
 *             routines for MicroEMACS v4.00 (patch level 05 and upper).
 *             (c)1999 Thierry Godefroy.
 */

#if CHRATTR

#define MAXWORDLENGTH       32

#define C_CONTROLS          12
static char *c_control[] =  { "if", "else", "do", "while", "for", "break",
                              "continue", "switch", "case", "default", "return",
                              "goto"
                            };

#define C_DECLARATIONS      18
static char *c_declare[] = { "void", "unsigned" ,"char", "short", "int", "long",
                             "double", "float", "static", "volatile", "auto",
                             "const", "struct", "enum", "typedef", "extern",
                             "register", "inline"
                           };


#define AS68_DIRECTIVES     26
static char *as68_directive[]= { ".DC.B", ".DC.W", ".DC.L", ".DATA1", ".DATA2",
                                 ".DATA4", ".DS.B", ".DS.W", ".DS.L", ".EQU",
                                 ".GLOBL", ".DEFINE", ".EXTERN", ".ALIGN",
                                 ".EVEN", ".ASCII", ".ASCIZ", ".SPACE", ".ORG",
                                 ".BSS", ".TEXT", ".DATA", ".COMM", ".SECT",
                                 ".END", ".ROM"
                               };

#define ASM_DIRECTIVES      121
static char *asm_directive[] = { "DC.B", "DC.W", "DC.L", "DS.B", "DS.W", "DS.L",
                                 "EQU", "XREF", "XREF.S", "XREF.L", "XDEF",
                                 "INCLUDE", "DCB.B", "DCB.W", "DCB.L", "MACRO",
                                 "ENDM", "SECTION", "MODULE", "ORG", "RORG",
                                 "COMMON", "OFFSET", "COMMENT", "DATA", "END",
                                 "PAGE", "PAGEWID", "PAGELEN", "LIST", "NOLIST",
                                 "TITLE", "LOCAL", "SETSTR", "SETNUM", "GOTO",
                                 "IFNUM", "IFSTR", "MACLAB",  "ALIGN", "CNOP",
                                 "EQUR", "FEQUR", "REG", "FREG", "DS.S", "DS.D",
                                 "DS.X", "DS.P", "DS.Q", "DC.S", "DC.D", "DC.X",
                                 "DC.P", "DC.Q", "DCB.B", "DCB.W", "DCB.L",
                                 "DCB.S", "DCB.D", "DCB.X", "DCB.P", "DCB.Q",
                                 "SET", "RS_SET", "RS.B", "RS.W", "RS.L",
                                 "RS.S", "RS.D", "RS.X", "RS.P", "RS.Q", "IN",
                                 "LIB", "MACROP", "MACL", "GOTO", "IF", "ELSE",
                                 "ENDIF", "END_IF", "ANDIF", "AND_IF", "ORIF",
                                 "OR_IF", "ELSEIF", "ELSE_IF", "IFLT", "IFEQ",
                                 "IFGT", "IFLE", "IFNE", "IFGE", "IFC", "IFNC",
                                 "ENDC", "ERR", "LST", "LOW_EA", "HIGH_EA",
                                 "68030", "68EC030", "68851", "68040", "68060",
                                 "CASE_DIFF", "CASE_IND", "UND_XREF", "UND_ERR",
                                 "NON_PC", "PC_REL", "REL_FILE", "O_FILE",
                                 "COM_DUM", "COM_ALL", "PCK", "PWID", "ERROR",
                                 "WARNING", "FILETYPE"
                               };

#define ASM_FUNCTIONS       28
static char *asm_function[]  = { ".PARM", ".NPARMS", ".DEF", ".LEN", ".LEFT",
                                 ".RIGHT", ".INSTR", ".UCASE", ".LAB", ".EXT",
                                 ".OTYPE", ".ABS", ".TIME", ".DATE", ".FILE",
                                 ".VER", ".OS", ".L", "#ABS", "#DEF", "#PLEN",
                                 "#LEN", "#LEFT", "#RIGHT", "#INSTR", "#UCASE",
                                 "#PARM", "#FR"
                               };

#define BAS_STRUCTURES      31
static char *bas_structure[] = { "END", "IF", "THEN", "ELSE", "REPEAT", "FOR",
                                 "STEP", "NEXT", "EXIT", "SELECT", "ON",
                                 "DEFINE", "PROCEDURE", "FUNCTION", "LOCAL",
                                 "RETURN", "DIM", "GO", "TO", "SUB", "WHEN",
                                 "ERROR", "CONTINUE", "RETRY", "LET", "RESTORE",
                                 "DATA", "READ", "MISTAKE", "STOP", "REMAINDER"
                               };

#define CMD_DIRECTIVES      10
static char *cmd_directives[] = { "!if", "!else", "!endif", "!return", "!goto",
                                  "!force", "!while", "!endwhile",
                                  "store-procedure", "!endm"
                               };
#endif
